# -*- coding: utf-8 -*-
"""
Created on Sun Aug  2 18:09:40 2020

@author: asano
"""

# 2章 数学の基礎を準備

# import numpy as asano  #勝手に略称をつけてもよい
import numpy as np

# 行列の和と差とスカラー倍
A =np.array([[1,3],[2,4]])    #2×2の行列
B =np.array([[0,-3],[-2,1]])  #2×2の行列
C = A + B
D = C - A
k = 0.1       # kはスカラーです
kA = k * A

a =np.array([5, 4, 4])  #3次の列ベクトル
b =np.array([3,-1,-2])  #3次の列ベクトル
c =a @ b  #ベクトルの内積
k =10     #スカラー
ka = k * a   #ベクトルのスカラー倍
c2 = a.T @ b #同じ内積が計算される
c3 = a @ b.T

A = np.array([[5, 4, 4],[6, 5, 4]])  #2行3列の行列
Ab = A @ b   #２次の列ベクトル
B = np.array([[3,4],[-1,-1],[-2,-3]])  #3行2列の行列
AB = A @ B   #2行2列の行列

# 特殊な行列とベクトル
I = np.identity(3)    #単位行列
vec1 = np.ones(3)     #単位ベクトル
O = np.zeros((3,4))   #ゼロ行列
vec0 = np.zeros(3)    #ゼロベクトル
1vec = np.ones(3)     #文法違反
0vec = np.zeros(3)    #文法違反

# 数値微分
import numpy as np

def derivative(f,x):
    h=1e-4
    return (f(x+h)-f(x))/h
    
def f2_3(x):
    return -x * np.exp(-3* x ** 2)

derivative(f2_3,0.2)
derivative(f2_3,0.4082)      
derivative(f2_3,1.0)

#コラム：行列とベクトルに一貫性がないnumpy
import numpy as np
a = np.array([1,2,3])
print(a)
a.shape
# 行列と行列の積
X = np.array([[1, 2], [3, 4]])
Y = np.array([[5, 6], [7, 8]])
S1 = X @ Y
print(S1)
S2 = X.T @ Y
print(S2)


