# -*- coding: utf-8 -*-
"""
Created on Mon Jun 24 14:27:34 2019

@author: asano
"""

# 4.4節排他的論理和ＸＯＲをニューラルネットで表す

import numpy as np

def step_function(x):
    return np.array(x > 0, dtype=np.int)

# パラメータの一つの例と観測データ
W1 = np.array([[-0.5, -0.5, 0.7], [0.5, 0.5, -0.2]])
W2 = np.array([0.5, 0.5,-0.7])
X = np.array([[0,1,0,1], [0,0,1,1]])
T = np.array([0,1,1,0])

N = 4   #組み合わせの数
vec1 = np.ones((1,N))
Xex  = np.vstack([X,vec1])

# ここからフォワードのプロセス
S = W1 @ Xex
Z = step_function(S)
Zex= np.vstack([Z ,vec1 ])
Sum = W2 @ Zex
Y = step_function(Sum)
Dif = Y - T



