# -*- coding: utf-8 -*-
"""
Created on Tue May 26 04:49:11 2020

@author: asano
"""

import numpy as np
import pandas as pd
import matplotlib.pyplot as plt
np.set_printoptions(precision=3,suppress=True )
# 線形分離不可能な判別データを作るだけのプログラムプログラム
N = 1000
x1 = np.random.rand(N)
x2 = np.random.rand(N)
G = np.ones(N)

for i in range(N):
    if x2[i]-2*x1[i] + 1 >0:
        if 2*x1[i]-x2[i] >0: #第2グループの定義
            G[i] =2
        
print ( "グループ2に置き換え終了")

X = np.vstack((x1,x2))

user = G.astype(str)
Tdata = pd.get_dummies(user)
Td = np.array(Tdata)
T = Td.T

Hanbetu =np.vstack((X,G))

Hanbetu = Hanbetu.T
np.savetxt('Hanbetu.csv',Hanbetu,fmt='%.3f',delimiter=',')

